<template>
  <div
    data-component-group="lists"
    data-component="comments"
  >
    <div
      v-if="!shouldDisplay(comments)"
      class="spinner"
    >
      <v-progress-circular
        :width="3"
        :size="24"
        indeterminate
        color="primary"
      />
    </div>
    <v-list
      v-else
      two-line
      class="comments-list"
    >
      <template v-for="(item, index) in comments">
        <v-list-tile
          :key="index"
          avatar
          class="comment-item"
        >
          <v-list-tile-avatar>
            <v-icon class="avatar-icon">
              account_circle
            </v-icon>
          </v-list-tile-avatar>

          <div class="tile-wrapper">
            <v-list-tile-title>
              <span class="actor">
                {{ getActorName(item) }}
              </span>
            </v-list-tile-title>
            <span class="comment-action">
              {{ getMessage(item) }}
            </span>
            <span
              class="comment"
              v-html="item.comment.text"
            ></span>
            <span class="timestamp">
              {{ item.updated_at }}
            </span>
            <div
              v-if="hasAttachments(item)"
              class="attachments"
            >
              <template v-for="(attachment, attachmentIndex) in item.attachments">
                <v-btn
                  :key="attachmentIndex"
                  :href="attachment.url"
                  target="_blank"
                  small
                  @click="downloadAttachment(attachment)"
                >
                  <v-icon>
                    file_download
                  </v-icon>
                  {{ attachment.name }}
                </v-btn>
              </template>
            </div>
          </div>
        </v-list-tile>
      </template>
    </v-list>
  </div>
</template>

<script>
  import download from 'downloadjs';
  import { isArr } from '../../utils';

  export default {
    props: {
      comments: {
        type: Array,
        required: true
      }
    },
    methods: {
      hasAttachments(item) {
        return isArr(item.attachments) && item.attachments.length > 0;
      },
      downloadAttachment(attachment) {
        download(attachment.url);
      },
      getActorName({ comment }) {
        return comment.actor;
      },
      getMessage({ comment, permissions }) {
        const { message } = comment;

        return this.$ability.can('see-comment-permissions', 'thread')
          ? `${message} (${permissions.name})`
          : `${message}`;
      },
      shouldDisplay(comments) {
        let shouldDisplay = true;

        comments.forEach(({ comment = {} }) => {
          if (!shouldDisplay) {
            return false;
          }

          const { actor = '' } = comment;
          shouldDisplay = actor !== '';
        });

        return shouldDisplay;
      }
    }
  };
</script>

<style lang="stylus">
  @import '../../assets/stylus/theme.styl';

  [data-component-group="lists"] {
    &[data-component="comments"] {
      .spinner {
        width: 100%;
        height: 80px;
        display: flex;
        justify-content: center;
        align-items: center;
      }

      .comments-list {
        overflow-x: hidden;
        border-radius: 4px;
        padding-top: 0;
        background-color: $colors.grey.lighten-2;
      }

      .v-list__tile__title {
        font-size: 13px;
        color: $colors.grey.darken-4;
      }

      .comment-action {
        font-size: 12px;
        margin: 6px 0 0 -30px;
        width: calc(100% + 20px);
      }

      .comment-item {
        padding: 0;
        border-bottom: 1px solid $colors.grey.lighten-2;

        &:last-child {
          border: none;
        }
      }

      .avatar-icon {
        font-size: 22px;
        color: $colors.grey.darken-4;
      }

      .action {
        color: $colors.grey.base;
      }

      .comment {
        display: block;
        margin: 6px 0 0 -30px;
        width: calc(100% + 20px);
        height: auto;
        word-break: break-all;
        font-size: 14px;
        padding: 8px;
        border-top-left-radius: 4px;
        border-top-right-radius: 4px;
        color: $colors.grey.darken-2;
        background-color: $colors.shades.white;

        p {
          font-size: 14px;
          margin-bottom: 8px;
          color: $colors.grey.darken-4;
        }
      }

      .attachments {
        margin: 6px 0 0 -30px;
        width: calc(100% + 20px);

        .v-btn {
          font-size: 12px;
          border-radius: 4px;
          margin: 4px;

          &:hover {
            &:before {
              background-color: $colors.grey.lighten-4;
            }
          }

          &:first-child {
            margin-left: 0;
          }

          .v-icon {
            font-size: 18x;
            margin: 0 6px 0 0;
          }
        }
      }

      .actor {
        position: relative;
        bottom: 2px;
      }

      .timestamp {
        display: block;
        margin: 0 0 0 -30px;
        padding: 0 8px 8px 8px;
        width: calc(100% + 20px);
        color: $colors.grey.base;
        background-color: $colors.shades.white;
        font-size: 12px;
        border-bottom-left-radius: 4px;
        border-bottom-right-radius: 4px;
      }

      .v-list__tile {
        height: auto;
        min-height: auto;
        padding: 0;
        align-items: flex-start;
      }

      .v-list__tile__avatar {
        min-width: 36px;
      }

      .tile-wrapper {
        width: 100%;
        padding: 10px 0 0 0;
      }
    }
  }
</style>
